# FramedSnappyCompressorInputStream (Apache Commons Compress 1.13 API)

org.apache.commons.compress.compressors.snappy

## Class FramedSnappyCompressorInputStream

- java.lang.Object
- - java.io.InputStream
  - - org.apache.commons.compress.compressors.CompressorInputStream
    - - org.apache.commons.compress.compressors.snappy.FramedSnappyCompressorInputStream

- All Implemented Interfaces:
    Closeable, AutoCloseable

      public class FramedSnappyCompressorInputStream
      extends CompressorInputStream

  CompressorInputStream for the framing Snappy format.

  Based on the "spec" in the version "Last revised: 2013-10-25"

  Since:
    1.7
  See Also:
    Snappy framing format description

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FramedSnappyCompressorInputStream(InputStream in)` Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream using the `FramedSnappyDialect.STANDARD` dialect.
    `FramedSnappyCompressorInputStream(InputStream in, FramedSnappyDialect dialect)` Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()`
    `void` | `close()`
    `static boolean` | `matches(byte[] signature, int length)` Checks if the signature matches what is expected for a .sz file.
    `int` | `read()`
    `int` | `read(byte[] b, int off, int len)`

    - ### Methods inherited from class org.apache.commons.compress.compressors.CompressorInputStream

      `count, count, getBytesRead, getCount, pushedBackBytes`

    - ### Methods inherited from class java.io.InputStream

      `mark, markSupported, read, reset, skip`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### FramedSnappyCompressorInputStream

          public FramedSnappyCompressorInputStream(InputStream in)
                                            throws IOException

      Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream using the `FramedSnappyDialect.STANDARD` dialect.
      Parameters:
        `in` - the InputStream from which to read the compressed data
      Throws:
        `IOException` - if reading fails

    - #### FramedSnappyCompressorInputStream

          public FramedSnappyCompressorInputStream(InputStream in,
                                           FramedSnappyDialect dialect)
                                            throws IOException

      Constructs a new input stream that decompresses snappy-framed-compressed data from the specified input stream.
      Parameters:
        `in` - the InputStream from which to read the compressed data
        `dialect` - the dialect used by the compressed stream
      Throws:
        `IOException` - if reading fails

  - ### Method Detail

    - #### read

          public int read()
                   throws IOException

      Specified by:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### close

          public void close()
                     throws IOException

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`
      Overrides:
        `close` in class `InputStream`
      Throws:
        `IOException`

    - #### read

          public int read(byte[] b,
                 int off,
                 int len)
                   throws IOException

      Overrides:
        `read` in class `InputStream`
      Throws:
        `IOException`

    - #### available

          public int available()
                        throws IOException

      Overrides:
        `available` in class `InputStream`
      Throws:
        `IOException`

    - #### matches

          public static boolean matches(byte[] signature,
                        int length)

      Checks if the signature matches what is expected for a .sz file.

      .sz files start with a chunk with tag 0xff and content sNaPpY.

      Parameters:
        `signature` - the bytes to check
        `length` - the number of bytes to check
      Returns:
        true if this is a .sz stream, false otherwise

Copyright © 2016 The Apache Software Foundation. All rights reserved.